Attribute VB_Name = "CommonModule"
Option Explicit

Public MainForm As frmPlayer

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal uMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const GWL_WNDPROC As Long = (-4&)
Private lpPrevWndProc As Long, hWndMain As Long

Private Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal Section As String, ByVal Key As String, ByVal Value As String, ByVal File As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal Section As String, ByVal Key As String, ByVal Default As String, ByVal Value As String, ByVal Length As Long, ByVal File As String) As Long

Public Sub FormHook()
If lpPrevWndProc <> 0 Then Exit Sub
hWndMain = MainForm.hWnd
lpPrevWndProc = SetWindowLong(hWndMain, GWL_WNDPROC, AddressOf frmPlayer_WndProc_Command)
End Sub

Public Sub FormUnHook()
If lpPrevWndProc = 0 Then Exit Sub
Call SetWindowLong(hWndMain, GWL_WNDPROC, lpPrevWndProc)
End Sub

Public Function frmPlayer_WndProc_Command(ByVal hWnd As Long, ByVal uMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
On Error Resume Next
Const WM_COMMAND As Long = &H111&
Dim ret As Long
Select Case uMessage
  Case WM_COMMAND
    ret = MainForm.HotKey(wParam And &HFFFF&)
    If ret = 0 Then
      frmPlayer_WndProc_Command = ret
    Else
      frmPlayer_WndProc_Command = CallWindowProc(lpPrevWndProc, hWnd, uMessage, wParam, lParam)
    End If
  Case Else
    frmPlayer_WndProc_Command = CallWindowProc(lpPrevWndProc, hWnd, uMessage, wParam, lParam)
End Select
End Function

Public Function GetIniValue(ByVal Section As String, ByVal Name As String, Optional ByVal Default As String) As String
Dim IniFile As String
IniFile = App.Path
If Right$(IniFile, 1) <> "\" Then IniFile = IniFile & "\"
IniFile = IniFile & App.EXEName & ".ini"
Dim ret As Long, res As String
res = Space$(1024)
ret = GetPrivateProfileString(Section, Name, Default, res, Len(res), IniFile)
If ret <= 0 Then
  GetIniValue = Default
  Exit Function
End If
res = Left$(res, ret): If InStr(res, " ;") > 0 Then res = RTrim$(Left$(res, InStr(res, " ;")))
GetIniValue = res
End Function

Public Sub SetIniValue(ByVal Section As String, ByVal Name As String, Optional ByVal Value As String, Optional ByVal DeleteKey As Boolean = False)
Dim IniFile As String
IniFile = App.Path
If Right$(IniFile, 1) <> "\" Then IniFile = IniFile & "\"
IniFile = IniFile & App.EXEName & ".ini"
If DeleteKey Then
  Call WritePrivateProfileString(Section, Name, vbNullString, IniFile)
Else
  Call WritePrivateProfileString(Section, Name, Value & vbNullChar, IniFile)
End If
End Sub
